unit uPrincip;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  IdMessageClient, IdPOP3, StdCtrls, ExtCtrls, Buttons, IdAntiFreezeBase,
  IdAntiFreeze, IdMessage, Pop3Prot;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    edServeur: TEdit;
    Label2: TLabel;
    edUser: TEdit;
    Label3: TLabel;
    edPass: TEdit;
    btnVerif: TSpeedButton;
    Bevel1: TBevel;
    lstMsgs: TListBox;
    Label4: TLabel;
    lblMsg: TLabel;
    cbxPass: TCheckBox;
    Label5: TLabel;
    edPort: TEdit;
    POP3: TPop3Cli;
    procedure edPassChange(Sender: TObject);
    procedure cbxPassClick(Sender: TObject);
    procedure btnVerifClick(Sender: TObject);
    procedure POP3RequestDone(Sender: TObject; RqType: TPop3Request;
      Error: Word);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.btnVerifClick(Sender: TObject);
begin

  lstMsgs.Clear;
  lblMsg.Caption := '-';

  //Mise  jour des donnes de connexion
  POP3.Host     := edServeur.Text;
  POP3.Port     := edPort.Text;
  POP3.Username := edUser.Text;

  //On spcifie le mode d'authentification suivant que le mot de passe est activ ou non
  If cbxPass.Checked then
  begin
    POP3.AuthType := popAuthLogin;
    POP3.Password := edPass.Text
  end
  else
  begin
    POP3.AuthType := popAuthNone;
    POP3.Password := '';
  end;

  try
    //Demande de la connexion. Open permet d'effectuer le processus de connexion (connect, user, pass) automatiquement
    POP3.Open;
  except
    on e: exception do
      ShowMessage(e.Message);
  end;
end;

procedure TForm1.POP3RequestDone(Sender: TObject; RqType: TPop3Request;
  Error: Word);
begin
  //Ici, on agit en fonction de la requte qui vient de se TERMINER
  Case RqType of
    pop3Open   : //Une fois la connexion tablie on appelle Stat, qui permet de rcuprer le nombre de messages
                 POP3.Stat;
    pop3Stat   : begin
                   //On affiche le nombre de messages
                   lblMsg.Caption := IntToStr(POP3.MsgCount);
                   //Retr permet de retrouver les headers du message nMsgNum 
                   POP3.MsgNum := 1;
                   POP3.Retr;
                 end;
    pop3Retr   : if Error = 0 then //Si pas d'erreur, cad si le message nMsgNum a t trouv
                 begin
                   //On prend les infos qui nous intressent
                   lstMsgs.Items.Add('"' + POP3.HeaderSubject + '" de ' + POP3.HeaderFrom);
                   //Et on passe au message suivant
                   POP3.MsgNum := POP3.MsgNum + 1;
                   POP3.Retr;
                 end
                 else
                   //Si le message n'existe pas, le listing est fini, on se dconnecte
                   POP3.Quit;
  end;
end;

procedure TForm1.edPassChange(Sender: TObject);
begin
  btnVerif.Enabled := (edServeur.Text <> '') and (edUser.Text <> '') and ((edPass.Text <> '') or not (cbxPass.Checked)) and (edPort.Text <> '');
end;

procedure TForm1.cbxPassClick(Sender: TObject);
begin
  edPass.Enabled := cbxPass.Checked;
end;

end.
